Class | Merb::Router
In: | lib/merb-core/dispatch/router.rb lib/merb-core/dispatch/router/resources.rb lib/merb-core/dispatch/router/cached_proc.rb lib/merb-core/dispatch/router/behavior.rb lib/merb-core/dispatch/router/route.rb
Parent: | Object

Router stores route definitions and finds the first route that matches the incoming request URL.

Then information from route is used by dispatcher to call action on the controller.

#### Routes compilation.

The most interesting method of Router (and heart of route matching machinery) is match method generated on the fly from routes definitions. It is called routes compilation. Generated match method body contains one if/elsif statement that picks the first matching route definition and sets values to named parameters of the route.

Compilation is synchronized by mutex.

### Methods

extensions prepare reset! resource route_for url

### Classes and Modules

Module Merb::Router::Resources
Class Merb::Router::Behavior
Class Merb::Router::CachedProc
Class Merb::Router::GenerationError
Class Merb::Router::NotCompiledError
Class Merb::Router::RouteNotFound

### External Aliases

match_before_compilation | -> | match
match_before_compilation | -> | match

### Attributes

around_match | [RW] | A block that will be run around route matching. This block must yield in order for the actual matching to happen. :api: plugin
named_routes | [RW] | A hash containing all the named application routes. The names are absolute (as in, all routes named in a namespace will contain the name of the namespace). :api: private

resource_routes

[RW]

A hash of all the application resource routes. The key of the hash is an array with each element containing the "path" for the resource for example, given the following resource routes:

resources :users do

      resources :comments

end

The show comment route will have a key of ["User", "Comment"]

:api: private

root_behavior

[RW]

The starting point for route definition. Any route defined in a Merb::Router.prepare block will defined in context of this behavior.

#### Examples

Merb::Router.root_behavior = Merb::Router.root_bavior.match("/hello")

In the previous example, all routes will have the path prefix /hello. It is important to note that this attribute must be set before any routes are defined in order for the behavior to be applied to the routes.

:api: plugin

routes | [RW] | An array containing all the application routes in order of priority. :api: private

### Public Class methods

extensions(&block)

Add functionality to the router. This can be in the form of including a new module or directly defining new methods.

#### Parameters

&block<Block>: | A block of code used to extend the route builder with. This can be including a module or directly defining some new methods that should be available to building routes.

#### Returns

nil

#### Example

      Merb::Router.extensions do
        def domain(name, domain, options={}, &block)
          match(:domain => domain).namespace(name, :path => nil, &block)
        end
      end

In this case, a method ‘domain’ will be available to the route builder which will create namespaces around domains instead of path prefixes.

This can then be used as follows.

      Merb::Router.prepare do
        domain(:admin, "my-admin.com") do
          # ... routes come here ...
        end
      end

:api: public

prepare(first = [], last = [], &block)

Creates a route building context and evaluates the block in it. A copy of `root_behavior` (and instance of Behavior) is copied as the context.

#### Parameters

first<Array>: | An array containing routes that should be prepended to the routes defined in the block.
last<Array>: | An array containing routes that should be appended to the routes defined in the block.

#### Returns

Merb::Router: | Returns self to allow chaining of methods.

:api: public

reset!()

Clears the routing table. Route generation and request matching won‘t work anymore until a new routing table is built.

:api: private

resource(*args)

Generates a URL from the resource(s)

#### Parameters

resources<Symbol,Object>: | The identifiers for the resource route to generate. These can either be symbols or objects. Symbols denote resource collection routes and objects denote the members.
params<Hash>: | Any extra parameters needed to generate the route.

#### Returns

String: | The generated URL

:api: plugin

route_for(request)

Finds route matching URI of the request and returns a tuple of [route index, route params]. This method is called by the dispatcher and isn‘t as useful in applications.

#### Parameters

request<Merb::Request>: | request to match.

#### Returns

Array[Integer, Hash]: | Two-tuple: route index and route parameters. Route parameters are :controller, :action and all the named segments of the route.

:api: private

url(name, *args)

There are three possible ways to use this method. First, if you have a named route, you can specify the route as the first parameter as a symbol and any paramters in a hash. Second, you can generate the default route by just passing the params hash, just passing the params hash. Finally, you can use the anonymous parameters. This allows you to specify the parameters to a named route in the order they appear in the router.

#### Parameters(Named Route)

name<Symbol>: | The name of the route.
args<Hash>: | Parameters for the route generation.

#### Parameters(Default Route)

args<Hash>: | Parameters for the route generation. This route will use the default route.

#### Parameters(Anonymous Parameters)

name<Symbol>: | The name of the route.
args<Array>: | An array of anonymous parameters to generate the route with. These parameters are assigned to the route parameters in the order that they are passed.

#### Returns

String: | The generated URL.

#### Examples

Named Route

Merb::Router.prepare do

      match("/articles/:title").to(:controller => :articles, :action => :show).name("articles")

end

url(:articles, :title => "new_article")

Default Route

Merb::Router.prepare do

      default_routes

end

url(:controller => "articles", :action => "new")

Anonymous Paramters

Merb::Router.prepare do

      match("/articles/:year/:month/:title").to(:controller => :articles, :action => :show).name("articles")

end

url(:articles, 2008, 10, "test_article")

:api: plugin

[Validate]